function Frodo_PlayRingSound()
   PlaySoundFile("Interface\\AddOns\\Frodo\\precious.ogg", "master");
end

Frodo_RingSlot = 11
Frodo_RingItemLevel = 735
Frodo_RingPercentageTable = {2500,2571,2642,2719,2796,2873,2956,3038,3124,3213,3305,3399,3494,3395,3695,3802,3908,4021,4133,4370}

function Frodo_CheckEquippedRing()
   local ringName = ""
   if IsEquippedItem("Nithramus, the All-Seer") then
	  ringName = "Nithramus, the All-Seer"
   elseif IsEquippedItem("Thorasus, the Stone Heart of Draenor") then
	  ringName = "Thorasus, the Stone Heart of Draenor"
   elseif IsEquippedItem("Maalus, the Blood Drinker") then
	  ringName = "Maalus, the Blood Drinker"
   end
   
   if ringName == "Nithramus, the All-Seer" then
	  Frodo_RingIcon.bgTex:SetTexture("Interface\\Icons\\inv_60legendary_ring1e")
	  Frodo_Frame:Show()
   elseif ringName == "Thorasus, the Stone Heart of Draenor" or ringName == "Maalus, the Blood Drinker" then
	  Frodo_RingIcon.bgTex:SetTexture("Interface\\Icons\\inv_60legendary_ring1c")
	  Frodo_Frame:Show()
   else
	  Frodo_Frame:Hide()
	  
   end
   Frodo_RingButton:SetAttribute("item", ringName);
   
   for i=11,12 do
	  local name, _, _, curItemLevel = GetItemInfo(GetInventoryItemLink("player",i))
	  if name == ringName then
		 Frodo_RingSlot = i
		 Frodo_RingItemLevel = curItemLevel   
	  end
   end
end

function Frodo_GetRingPercentage()
   return Frodo_RingPercentageTable[(Frodo_RingItemLevel - 735) / 3 +1] / 100
end

Frodo_Frame = CreateFrame("Frame", "Frodo_Frame", UIParent)
Frodo_Frame:SetWidth(200)
Frodo_Frame:SetHeight(64)
Frodo_Frame.bgTex = Frodo_Frame:CreateTexture("ARTWORK")
Frodo_Frame.bgTex:SetTexture(0, 0, 0)
Frodo_Frame.bgTex:SetAlpha(0.2)
Frodo_Frame.bgTex:SetAllPoints(Frodo_Frame)
Frodo_Frame:SetPoint("CENTER", -228, 264)
Frodo_Frame:Show()
Frodo_Frame:SetMovable(true)
Frodo_Frame:EnableMouse(true)
Frodo_Frame:RegisterForDrag("LeftButton")
Frodo_Frame:SetScript("OnDragStart", Frodo_Frame.StartMoving)
Frodo_Frame:SetScript("OnDragStop", Frodo_Frame.StopMovingOrSizing)

Frodo_Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
Frodo_Frame:RegisterEvent("UNIT_INVENTORY_CHANGED");
Frodo_Frame:RegisterEvent("PLAYER_REGEN_DISABLED");
Frodo_Frame:RegisterEvent("PLAYER_ENTERING_WORLD");

Frodo_Frame.countDamage = false
Frodo_Frame.currentAmount = 0
Frodo_Frame.totalAmount = 0

function Frodo_UpdateDisplay()
   Frodo_CurrentDmg:SetText("Current: " .. math.floor(Frodo_GetRingPercentage()/100 * Frodo_Frame.currentAmount / 1000) .. "K")
   Frodo_TotalDmg:SetText("Total:    " .. math.floor(Frodo_GetRingPercentage()/100 * Frodo_Frame.totalAmount / 1000) .. "K")
end

function Frodo_AddDamage(amount)
   if Frodo_Frame.countDamage then
	  Frodo_Frame.currentAmount = Frodo_Frame.currentAmount + amount
	  Frodo_Frame.totalAmount = Frodo_Frame.totalAmount + amount
	  Frodo_UpdateDisplay()
   end
end

function Frodo_ResetDamage()
   if not Frodo_Frame.countDamage then
	  Frodo_RingUser:SetText("Ring User")
   end
   
   Frodo_Frame.currentAmount = 0
   Frodo_Frame.totalAmount = 0
   
   Frodo_UpdateDisplay()
end

function Frodo_Init()
if Frodo_Initialized then
	return
end
Frodo_Initialized = true

	Frodo_RingIcon = CreateFrame("Frame", "Frodo_RingIcon", Frodo_Frame)
	Frodo_RingIcon:SetWidth(64)
	Frodo_RingIcon:SetHeight(64)
	Frodo_RingIcon.bgTex = Frodo_RingIcon:CreateTexture("ARTWORK")

	Frodo_RingButton = CreateFrame("Button", "Frodo_RingButton", Frodo_RingIcon, "SecureActionButtonTemplate");
	Frodo_RingButton:SetWidth(64)
	Frodo_RingButton:SetHeight(64)
	Frodo_RingButton:SetPoint("TOPLEFT", 0, 0)
	Frodo_RingButton:SetAttribute("type", "item");

	Frodo_CheckEquippedRing()

	Frodo_RingIcon.bgTex:SetAllPoints(Frodo_RingIcon)
	Frodo_RingIcon.bgTex:SetAlpha(1.0)
	Frodo_RingIcon:SetPoint("TOPLEFT", 0, 0)
	Frodo_RingIcon:Show()

	Frodo_CooldownIndicator = CreateFrame("Cooldown", "Frodo_CooldownIndicator", Frodo_RingIcon, "CooldownFrameTemplate")
	Frodo_CooldownIndicator:SetAllPoints(Frodo_RingIcon)
	Frodo_CooldownIndicator:SetCooldown(GetInventoryItemCooldown("player", Frodo_RingSlot))

	Frodo_RingUser = Frodo_Frame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	Frodo_RingUser:SetPoint("TOPLEFT", Frodo_RingIcon:GetWidth() + 8, -4)
	Frodo_RingUser:SetSize(0, 20)
	Frodo_RingUser:SetText("Ring User")

	Frodo_CurrentDmg = Frodo_Frame:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	Frodo_CurrentDmg:SetPoint("TOPLEFT", Frodo_RingIcon:GetWidth() + 8, -26)
	Frodo_CurrentDmg:SetSize(0, 16)
	Frodo_CurrentDmg:SetText("")

	Frodo_TotalDmg = Frodo_Frame:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	Frodo_TotalDmg:SetPoint("TOPLEFT", Frodo_RingIcon:GetWidth() + 8, -26-16)
	Frodo_TotalDmg:SetSize(0, 16)
	Frodo_TotalDmg:SetText("")
	
	Frodo_UpdateDisplay()
end


function Frodo_OnEvent(self, event, ...)
   local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
   if event == "PLAYER_ENTERING_WORLD" then
	  Frodo_Init()
   elseif (event=="UNIT_INVENTORY_CHANGED") then
	  Frodo_CheckEquippedRing()
   elseif (event=="PLAYER_REGEN_DISABLED") then
	  Frodo_ResetDamage()
   elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then
	  if (type=="SPELL_AURA_APPLIED") then
		 if UnitGUID("player") == destGUID then
			local spellId = select(12, ...)
			
			if spellId == 187616 or spellId == 187619 or spellId == 187620 then
			   Frodo_RingUser:SetText(sourceName)
			   ActionButton_ShowOverlayGlow(Frodo_RingButton);
			   Frodo_PlayRingSound()
			   Frodo_Frame.countDamage = true
			   Frodo_Frame.currentAmount = 0
			   Frodo_AddDamage(0)
			   Frodo_CooldownIndicator:SetCooldown(GetTime(), 15.0)
			end
		 end
	  elseif (type=="SPELL_AURA_REMOVED") then
		 if UnitGUID("player") == destGUID then
			local spellId = select(12, ...)
			
			if spellId == 187616 then
			   ActionButton_HideOverlayGlow(Frodo_RingButton);
			   Frodo_Frame.countDamage = false
			   Frodo_CooldownIndicator:SetCooldown(GetInventoryItemCooldown("player", Frodo_RingSlot))
			end
		 end
	  elseif type =="SPELL_DAMAGE" or type =="RANGE_DAMAGE" or type == "SPELL_PERIODIC_DAMAGE" or type == "SPELL_BUILDING_DAMAGE" then
		 if UnitGUID("player") == sourceGUID then
			local amount = select(15, ...)
			Frodo_AddDamage(amount)
		 end
	  elseif type =="SWING_DAMAGE" then
		 if UnitGUID("player") == sourceGUID then
			local amount = select(12, ...)
			Frodo_AddDamage(amount)
		 end
	  end
   end
end

Frodo_Frame:SetScript("OnEvent", Frodo_OnEvent);

